"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useDBOptions = useDBOptions;
exports.useDBContext = useDBContext;
exports.default = useDB;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = require("react");

var _pouchdbBrowser = _interopRequireDefault(require("pouchdb-browser"));

var _fastJsonStableStringify = _interopRequireDefault(require("fast-json-stable-stringify"));

var _DBContext = _interopRequireDefault(require("./DBContext"));

var _pouchdbConnections = require("./pouchdbConnections");

function useDBOptions(options) {
  var key = (0, _fastJsonStableStringify.default)(options);

  var _useState = (0, _react.useState)(options),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      prevOptions = _useState2[0],
      setPrevOptions = _useState2[1];

  var _useState3 = (0, _react.useState)(key),
      _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
      prevKey = _useState4[0],
      setPrevKey = _useState4[1];

  var _useState5 = (0, _react.useState)(options ? function () {
    return (0, _pouchdbConnections.create)(options);
  } : undefined),
      _useState6 = (0, _slicedToArray2.default)(_useState5, 2),
      db = _useState6[0],
      setDB = _useState6[1];

  if (key !== prevKey) {
    if (prevOptions) {
      (0, _pouchdbConnections.close)(prevOptions);
    }

    if (options) {
      setDB((0, _pouchdbConnections.create)(options));
    }

    setPrevOptions(options);
    setPrevKey(key);
  }

  return db;
}

function useDBContext() {
  return (0, _react.useContext)(_DBContext.default);
}

function useDB(any) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref$callee = _ref.callee,
      callee = _ref$callee === void 0 ? 'useDB' : _ref$callee,
      _ref$example = _ref.example,
      example = _ref$example === void 0 ? 'useDB(options)' : _ref$example;

  var dbInstance = any instanceof _pouchdbBrowser.default ? any : undefined;
  var options = dbInstance ? undefined : any;
  var dbOptions = useDBOptions(options);
  var dbContext = useDBContext();
  var db = dbInstance || dbOptions || dbContext;

  if (!db) {
    throw new Error(callee ? "`".concat(callee, "` was called without `db` and database is not in context. Provide database using <PouchDB /> or `").concat(example, "`") : 'Database is not in context. Provide database using <PouchDB />');
  }

  return db;
}
//# sourceMappingURL=useDB.js.map