"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = require("react");

var _useDB = _interopRequireDefault(require("./useDB"));

var _default = function _default(useDBOperation, error) {
  return function (_ref) {
    var db = _ref.db,
        children = _ref.children,
        component = _ref.component,
        render = _ref.render,
        otherProps = (0, _objectWithoutProperties2.default)(_ref, ["db", "children", "component", "render"]);
    var props = {
      db: (0, _useDB.default)(db, error)
    };

    try {
      Object.assign(props, db ? useDBOperation(db, otherProps) : useDBOperation(otherProps));
    } catch (error) {
      if (component || render) {
        throw error;
      }
    }

    if (component) {
      return (0, _react.createElement)(component, props);
    }

    if (render) {
      return render(props);
    }

    if (typeof children === 'function') {
      return children.prototype.render ? (0, _react.createElement)(children, props) : children(props);
    }

    if (children && _react.Children.count(children)) {
      return (0, _react.cloneElement)(children, props);
    }
  };
};

exports.default = _default;
//# sourceMappingURL=renderProps.js.map