import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import { useContext, useState } from 'react';
import PouchDB from "pouchdb-node";
import stringify from 'fast-json-stable-stringify';
import DBContext from './DBContext';
import { create, close } from './pouchdbConnections';
export function useDBOptions(options) {
  var key = stringify(options);

  var _useState = useState(options),
      _useState2 = _slicedToArray(_useState, 2),
      prevOptions = _useState2[0],
      setPrevOptions = _useState2[1];

  var _useState3 = useState(key),
      _useState4 = _slicedToArray(_useState3, 2),
      prevKey = _useState4[0],
      setPrevKey = _useState4[1];

  var _useState5 = useState(options ? function () {
    return create(options);
  } : undefined),
      _useState6 = _slicedToArray(_useState5, 2),
      db = _useState6[0],
      setDB = _useState6[1];

  if (key !== prevKey) {
    if (prevOptions) {
      close(prevOptions);
    }

    if (options) {
      setDB(create(options));
    }

    setPrevOptions(options);
    setPrevKey(key);
  }

  return db;
}
export function useDBContext() {
  return useContext(DBContext);
}
export default function useDB(any) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref$callee = _ref.callee,
      callee = _ref$callee === void 0 ? 'useDB' : _ref$callee,
      _ref$example = _ref.example,
      example = _ref$example === void 0 ? 'useDB(options)' : _ref$example;

  var dbInstance = any instanceof PouchDB ? any : undefined;
  var options = dbInstance ? undefined : any;
  var dbOptions = useDBOptions(options);
  var dbContext = useDBContext();
  var db = dbInstance || dbOptions || dbContext;

  if (!db) {
    throw new Error(callee ? "`".concat(callee, "` was called without `db` and database is not in context. Provide database using <PouchDB /> or `").concat(example, "`") : 'Database is not in context. Provide database using <PouchDB />');
  }

  return db;
}
//# sourceMappingURL=useDB.js.map